<?php

/**
 * ArtHelper Addon.
 *
 * @author post[at]thomasgoellner[dot]de Thomas Goellner
 *
 * @package redaxo5
 *
 * @var rex_addon $this
 */

$message = '';

if (rex_post('btn_save', 'string') != '') {
    $this->setConfig(rex_post('settings', [
        ['default_css', 'string'],
        ['multiple_css', 'boolean']
    ]));

    $message = $this->i18n('config_saved_successful');
}

if ($message != '') {
    echo rex_view::success($message);
}

$content = '';

$content .= '<fieldset><legend>' . $this->i18n('arthelper_css') . '</legend>';

$formElements = [];
$n = [];
$n['label'] = '<label for="arthelper-default-css">' . $this->i18n('default_css') . '</label>';
    $n['field'] = '<textarea class="form-control" id="arthelper-default-css" name="settings[default_css]" cols="10" rows="5">' . $this->getConfig('default_css') . '</textarea>'.
    '<p class="help-block rex-note">' . $this->i18n('default_css_help') . '<br /><code>css-class : CSS class description</code><br /><code>another-class : Another description</code></p>';
$formElements[] = $n;

$n = [];
$n['label'] = '' . $this->i18n('multiple_css') . '';
$n['field'] = '<div class="checkbox">'.
                '<label class="control-label help-block rex-note" for="arthelper-multiple-css"><input type="checkbox" name="settings[multiple_css]" value="1" id="arthelper-multiple-css"' . ((bool) $this->getConfig('multiple_css') ? ' checked="checked"' : '') . ' />' .
                '(' . $this->i18n('multiple_css_help') . ')' . 
                '</label></div>';

$formElements[] = $n;

$fragment = new rex_fragment();
$fragment->setVar('elements', $formElements, false);
$content .= $fragment->parse('core/form/form.php');

$content .= '</fieldset>';

$formElements = [];
$n = [];
$n['field'] = '<button class="btn btn-save rex-form-aligned" type="submit" name="btn_save" value="' . $this->i18n('save') . '">' . $this->i18n('save') . '</button>';
$formElements[] = $n;

$fragment = new rex_fragment();
$fragment->setVar('flush', true);
$fragment->setVar('elements', $formElements, false);
$buttons = $fragment->parse('core/form/submit.php');

$fragment = new rex_fragment();
$fragment->setVar('class', 'edit', false);
$fragment->setVar('title', $this->i18n('extras'), false);
$fragment->setVar('body', $content, false);
$fragment->setVar('buttons', $buttons, false);
$content = $fragment->parse('core/page/section.php');

echo '
    <form action="' . rex_url::currentBackendPage() . '" method="post">
        ' . $content . '
    </form>';
