<?php

/**
 * ArtHelper Addon.
 *
 * @author post[at]thomasgoellner[dot]de Thomas Goellner
 *
 * @package redaxo5
 *
 * @var rex_addon $addon
 */

$addon = rex_addon::get('arthelper');


$select_css = [];
if($tmp = $addon->getConfig('default_css')) {
	$tmp = explode("\n", $tmp);
	$assoc = null;

	foreach($tmp as $tmp_line) {
		$tmp_line = trim($tmp_line);
		if(!empty($tmp_line)) {
			$key = ''; $val = '';
			if(($p = strpos($tmp_line, ':'))!==false) {
				$key = trim(substr($tmp_line,0,$p));
				$val = str_replace('=',' ',trim(substr($tmp_line,$p+1)));
			}
			else {
				$key = $tmp_line;
				$val = $tmp_line;
			}

			if($assoc == null) {
				$assoc = $key != $val;
			}

			if($assoc) {
				$select_css[] = $val . '=' . $key;
			}
			else {
				$select_css[] = $val;
			}
			unset($key,$val,$p);
		}
	}

	if(!empty($select_css)) {
		if(!(bool) $addon->getConfig('multiple_css')) {
			$tmp = '';
			if($assoc) {
				$tmp = rex_i18n::msg('arthelper_none') . '=';
			}
			array_unshift($select_css, $tmp);
		}
	}
	unset($tmp,$tmp_line,$assoc);
}

$content = '';
$addon = rex_addon::get('arthelper');

if(isset($params)) {
	foreach(array('article_id','clang','ctype') as $type) {
		if(!isset($$ype)) {
			if(isset($params[$type])) {
				$$type = $params[$type];
			}
			else {
				throw new rex_exception('Error: ' . $type . ' not set.');
			}
		}
	}
}

$index_setting = [];
$index_setting[] = rex_i18n::msg('yrewrite_index_status').'=0';
$index_setting[] = rex_i18n::msg('yrewrite_index_index').'=1';
$index_setting[] = rex_i18n::msg('yrewrite_index_noindex').'=-1';

$yform = new rex_yform();
$yform->setObjectparams('form_action', rex_url::backendController(['page' => 'content/edit', 'article_id' => $article_id, 'clang' => $clang, 'ctype' => $ctype], false));
$yform->setObjectparams('form_id', 'arthelper-extras');
$yform->setObjectparams('form_name', 'arthelper-extras');
$yform->setHiddenField('arthelper_func', 'extras');

$yform->setObjectparams('form_showformafterupdate', 1);

$yform->setObjectparams('main_table', rex::getTable('article'));
$yform->setObjectparams('main_id', $article_id);
$yform->setObjectparams('main_where', 'id='.$article_id.' and clang_id='.$clang);
$yform->setObjectparams('getdata', true);

if($clang != 1) {
	$yform->setValueField('checkbox', ['arthelper_use_root', rex_i18n::msg('arthelper_use_root')]);
}

if(!empty($select_css) && is_array($select_css)) {
	$opts = ['arthelper_css', rex_i18n::msg('arthelper_css'), implode(',', $select_css)];
	if((bool) $addon->getConfig('multiple_css')) {
		$opts['size'] = 5;
		$opts['multiple'] = 1;
		$opts['readonly'] = true;
	}
	$yform->setValueField('select', $opts);
	unset($opts, $select_css);
}
else {
	$yform->setValueField('text', ['arthelper_css', rex_i18n::msg('arthelper_css')]);
}

$yform->setValueField('checkbox', ['arthelper_ignore_pcss', rex_i18n::msg('arthelper_ignore_pcss')]);

$yform->setActionField('db', [rex::getTable('article'), 'id=' . $article_id.' and clang_id='.$clang]);
$yform->setObjectparams('submit_btn_label', $addon->i18n('arthelper_update'));
$form = $yform->getForm();

if ($yform->objparams['actions_executed']) {

    $form = rex_view::success(rex_i18n::msg('arthelper_extrasupdated')) . $form;
    rex_article_cache::delete($article_id, $clang);

} else {

}

$form = '<section id="rex-page-sidebar-arthelper-extras" data-pjax-container="#rex-page-sidebar-arthelper-extras" data-pjax-no-history="1">'.$form.'</section>';

if($clang != 1) {
	$form.='<script type="text/javascript">if(jQuery("#yform-arthelper-extras-field-0").length) {
	jQuery("body").on("rex:ready", function(){
		jQuery("#yform-arthelper-extras-field-0").first().on({
			"deactform.arthelper" : function(e){
				var disabled = jQuery(this).prop("checked");
				jQuery("#yform-arthelper-extras-arthelper_css, #yform-arthelper-extras-arthelper_ignore_pcss").each(function(i,el){
					$(el)
					.css({display: disabled ? "none" : "block"})
					.find("input")
					.prop("disabled",disabled);
				});
			},
			"change.arthelper" : function(e) {
				jQuery(this).trigger("deactform.arthelper");
			}
		}).trigger("deactform.arthelper");
	});
}

</script>';
}

return $form;
